#ifndef GAME_HPP
#define GAME_HPP

#include "Common.hpp"
#include "Map.hpp"

class Game
{
public:
    Game();
    ~Game();

    bool checkAndApply(const std::vector<uint32_t>& route,
                       bool bApply,
                       std::string* pMsg = nullptr);

    void initOptionsLeft();

    void serialize(std::vector<uint32_t>* pData) const;
    bool deserialize(const std::vector<uint32_t>& data, size_t& pos);

public:
    uint32_t m_punter;
    uint32_t m_numPunters;
    bool m_useFutures;
    bool m_useSplurges;
    bool m_useOptions;
    Map m_map;
    std::vector<uint32_t> m_claims;
    std::vector<uint32_t> m_options;
    std::vector<uint32_t> m_optionsLeft;
};

#endif
