#ifndef GREEDYSOLVER_HPP
#define GREEDYSOLVER_HPP

#include "Common.hpp"
#include "Solver.hpp"

class GreedySolver : public Solver
{
public:
    GreedySolver();
    virtual ~GreedySolver() override;

    virtual void solve(const Game& game,
                       std::vector<uint32_t>* pRoute) override;
    virtual void getFutures(const Game& game,
                            std::vector<SolverFuture>* pFutures) override;
    virtual void serialize(std::vector<uint32_t>* pData) const override;
    virtual bool deserialize(const std::vector<uint32_t>& data,
                             size_t& pos) override;

private:
    bool m_haveFirstMove;
    uint32_t m_firstSource;
    uint32_t m_firstTarget;
};

#endif
