#ifndef PLANSOLVER_HPP
#define PLANSOLVER_HPP

#include "Common.hpp"
#include "Solver.hpp"

class PlanSolver : public Solver
{
public:
    PlanSolver(bool splurge, bool test);
    virtual ~PlanSolver() override;

    virtual void solve(const Game& game,
                       std::vector<uint32_t>* pRoute) override;
    virtual void getFutures(const Game& game,
                            std::vector<SolverFuture>* pFutures) override;
    virtual void serialize(std::vector<uint32_t>* pData) const override;
    virtual bool deserialize(const std::vector<uint32_t>& data,
                             size_t& pos) override;

private:
    bool m_splurge;
    bool m_test;
    bool m_haveFirstMove;
    uint32_t m_firstSource;
    uint32_t m_firstTarget;
    uint32_t m_turn;
};

#endif
