#ifndef SOLVER_HPP
#define SOLVER_HPP

#include "Common.hpp"

class Game;

class SolverFuture
{
public:
    SolverFuture() : m_source(0), m_target(0) {}
    SolverFuture(uint32_t source, uint32_t target) :
        m_source(source), m_target(target) {}

    uint32_t m_source;
    uint32_t m_target;
};

class Solver
{
public:
    Solver();
    virtual ~Solver();

    virtual void solve(const Game& game,
                       std::vector<uint32_t>* pRoute) = 0;
    virtual void getFutures(const Game& game,
                            std::vector<SolverFuture>* pFutures);
    virtual void serialize(std::vector<uint32_t>* pData) const;
    virtual bool deserialize(const std::vector<uint32_t>& data,
                             size_t& pos);
};

#endif
