#include "SolverFactory.hpp"
#include "PassSolver.hpp"
#include "RandomSolver.hpp"
#include "SequentialSolver.hpp"
#include "GreedySolver.hpp"
#include "PlanSolver.hpp"

using std::string;
using std::vector;

namespace SolverFactory
{
    vector<string> getList()
    {
        return
        {
            "pass",
            "random",
            "sequential",
            "greedy",
            "plan",
            "splurge",
            "test"
        };
    }

    std::unique_ptr<Solver> create(const string& name)
    {
        if (name == "pass") return std::make_unique<PassSolver>();
        if (name == "random") return std::make_unique<RandomSolver>();
        if (name == "sequential") return std::make_unique<SequentialSolver>();
        if (name == "greedy") return std::make_unique<GreedySolver>();
        if (name == "plan") return std::make_unique<PlanSolver>(false, false);
        if (name == "splurge") return std::make_unique<PlanSolver>(true, false);
        if (name == "test") return std::make_unique<PlanSolver>(false, true);

        return nullptr;
    }
}
