#include "Common.hpp"
#include "Program.hpp"
#include "Solver.hpp"
#include "SolverFactory.hpp"

using std::string;
using std::vector;

int main(int argc, char *argv[])
{
    vector<string> args;
    for (int iArg = 1; iArg < argc; iArg++)
    {
        args.push_back(argv[iArg]);
    }

    string solverName = "plan";

    std::unique_ptr<Solver> pSolver(SolverFactory::create(solverName));
    if (!pSolver)
    {
        fprintf(stderr, "Error creating solver\n");
        return 1;
    }

    Program program(*pSolver, "Frictionless Bananas", "punter");
    return program.run(args);
}
